import unittest

import support
support.initthuban()

from Thuban.UI.mapping import Mapping

class TestMapping(unittest.TestCase):

    def test_mapping(self):
        class MyClass:
            pass

        class MySecondClass:
            def hello(self):
                return "Hello World!"

        mapping = Mapping()
        instance = MyClass()

        # See if an empty mapping really returns False
        #
        self.assertEqual(mapping.get_class(instance), None)
        self.assertEqual(mapping.has_mapping(instance), False)

        # See if an installed mapping works
        #
        mapping.register_class(MyClass, MySecondClass)
        self.assertEqual(mapping.get_class(instance), MySecondClass)
        self.assertEqual(mapping.has_mapping(instance), True)

        # Ensure that it's really the class we put in and the method
        # is available as expected.
        #
        myinst = mapping.get_class(instance)()
        self.assertEqual(myinst.hello(), "Hello World!")


if __name__ == "__main__":
    support.run_tests()
